module IndRec where

open import Data.Nat
open import Data.Product
open import Data.Unit
open import Data.Empty
open import Data.Fin hiding (lift)

data Codes : Set where nat pi set lift : Codes

mutual 

  U' : ℕ → Codes → ℕ → Set
  U' n nat k       = ⊤
  U' n pi  zero    = ⊥
  U' n pi  (suc k) = ∃ λ (a : U n k) → El n k a → U n k
  U' n set k       = Fin n
  U' n lift k      = ℕ

  U : ℕ → ℕ → Set
  U n k = ∃ λ c → U' n c k

  El : (n k : ℕ) → U n k → Set
  El n k       (nat , _)    = ℕ  
  El n zero    (pi , ())
  El n (suc k) (pi , a , f) = (x : El n k a) -> El n k (f x)
  El zero k    (lift , k')  = ⊥
  El (suc n) k (lift , k')  = U n k'
  El n k       (set , i)    = U (toℕ i) k 
{-
  El zero k    (set , ()) 
  El (suc n) k (set , zero)    = U zero k 
  El (suc n) k (set , suc i)   = 
-}

PolyId : U 1 2
PolyId = pi , (set , # 0) , λ a → pi , {!a!} , {!!} -- a , λ x → ?

